'''
Exceptions for a failure of an analysis. Use this if an 
analysis has a failure mode which should throw an exception 
and no standard exception is apropriate.

Author: Simon Wilshin
Created: 10/10/2011
'''

class AnalysisError(Exception):
    '''
    An exception to be thrown in the event of an analysis specific error
    '''
    def __init__(self, value):
        '''
        Constructor, can be passed a value which is reported when 
        the exception is printed.
        @param value: Specific details about the exception
        @type k: any
        '''
        self.value = value
    def __str__(self):
        '''
        For when the exception gets printed, just print the string 
        representation of the value passed at construction.
        '''
        return repr(self.value)