'''
Created on 4 Feb 2011

@author: swilshin
'''

import numpy as np

def getTablaux(n):
    tablaux=list()
    for rows in range(1,n+1):
        for phaseNum in range(0,rows**n):
            digits=list()
            pN=phaseNum
            for k in range(0,n): #@UnusedVariable Just a loop
                digits.append(pN%rows)
                pN-=pN%rows
                pN/=rows
            if digits[0]==0:
                tab=[]
                consistent=True
                for i in range(0,rows):
                    if digits.count(i)==0:
                        consistent=False
                    tab.append([foot for foot in range(0,n) if digits[foot]==i])
                if consistent:
                    tablaux.append({'tablaux':tab,'phases':np.array(digits)*2.0*np.pi/float(rows)})
    return tablaux

# Testing
def testGetTablaux():
    print "Testing the getTablaux function."
    t1 = getTablaux(0)==[]
    print "Test 0001 Passed: ", t1
    t2 = getTablaux(1)==[{'tablaux':[[0]],'phases':[0.0]}]
    print "Test 0002 Passed: ", t2
    tab=getTablaux(2)
    t3 = tab[0]['tablaux'][0][0]==0
    print "Test 0003 Passed: ", t3
    t4 = tab[0]['tablaux'][0][1]==1
    print "Test 0004 Passed: ", t4
    t5 = tab[1]['tablaux'][0][0]==0
    print "Test 0005 Passed: ", t5    
    t6 = tab[1]['tablaux'][1][0]==1
    print "Test 0006 Passed: ", t6
    t7 = tab[0]['phases'][0]==0
    print "Test 0007 Passed: ", t7
    t8 = tab[0]['phases'][1]==0
    print "Test 0008 Passed: ", t8
    t9 = tab[1]['phases'][0]==0
    print "Test 0009 Passed: ", t9   
    t10 = tab[1]['phases'][1]==np.pi
    print "Test 0010 Passed: ", t10
    testsPassed=t1 and t2 and t3 and t4 and t5 and t6 and t7 and t8 and t9 and t10
    return(testsPassed)

def testyoungTablaux():
    t1=testGetTablaux()
    testsPassed=t1
    if testsPassed:
        print "All tests PASSED in module getTablaux."
    else:
        print "Some tests FAILED in module getTablaux!"
    return(testsPassed)
    
if __name__=='__main__':
    '''
    Run some tests, should print True if everything worked
    '''
    testyoungTablaux()